﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Syncfusion.JavaScript.DataVisualization.Models.Diagram;
using Syncfusion.JavaScript.DataVisualization.Models.Collections;
using Syncfusion.JavaScript.DataVisualization.Models;
using Syncfusion.JavaScript.DataVisualization.DiagramEnums;

namespace WebApplication2
{
    public partial class BPMNShapes : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitializePalette();
            }
            BasicShape node = new BasicShape();
            node.Name = "ram";
            node.OffsetX = 150;
            node.OffsetY = 100;
            node.Width = 100;
            node.Height = 100;
            node.Shape = BasicShapes.Ellipse;
            Label label = new Label();
            label.Text = "Left Align";
            label.HorizontalAlignment = HorizontalAlignment.Left;
            label.FontSize = 22;
            DiagramPoint offset = new DiagramPoint();
            offset.X = 0.1f;
            offset.Y = 0.5f;
            label.Offset = offset; 
            //add label to node labels collection
            node.Labels.Add(label);           
            Diagram1.Nodes.Add(node);


            BasicShape node1 = new BasicShape();
            node1.Name = "Center Align";
            node1.OffsetX = 300;
            node1.OffsetY = 100;
            node1.Width = 100;
            node1.Height = 100;
            node1.Shape = BasicShapes.Rectangle;
            Label label1 = new Label();
            label1.Text = "center Align";
            label1.HorizontalAlignment = HorizontalAlignment.Center;
            label1.FontSize = 22;
            DiagramPoint offset1 = new DiagramPoint();
            offset1.X = 0.5f;
            offset1.Y = 0.5f;
            label1.Offset = offset1;
            //add label to node labels collection
            node1.Labels.Add(label1); 
            node1.Ports.Add(GetPort(0, 0.5f, "port1"));
            node1.Ports.Add(GetPort(0.5f, 0, "port2"));
            node1.Ports.Add(GetPort(1, 0.5f, "port3"));
            node1.Ports.Add(GetPort(0.5f, 1, "port4"));
            Diagram1.Nodes.Add(node1);

            BasicShape node2 = new BasicShape();
            node2.Name = "node2";
            node2.OffsetX = 500;
            node2.OffsetY = 100;
            node2.Width = 100;
            node2.Height = 100;
            node2.Shape = BasicShapes.Rectangle;
            Label label2 = new Label();
            label2.Text = "Right Align";
            label2.HorizontalAlignment = HorizontalAlignment.Right;
            label2.FontSize = 22;
            DiagramPoint offset2 = new DiagramPoint();
            offset2.X = 1;
            offset2.Y = 0.5f;
            label2.Offset = offset2;
            //add label to node labels collection
            node2.Labels.Add(label2); 
            Diagram1.Nodes.Add(node2);
             
            Diagram1.EnableContextMenu = true;
            
        }
        private Port GetPort(float offsetX, float offsetY, string name)
        {

            Port port = new Port();

            port.Name = name;

            port.Visibility = PortVisibility.Visible;

            port.FillColor = "yellow";

            port.Shape = PortShapes.Square;

            port.Offset = new DiagramPoint(offsetX, offsetY);

            return port;

        }
        private void InitializePalette()
        {
            symbolpalette.Height = "100%";
            symbolpalette.Width = "250px";
            symbolpalette.PaletteItemHeight = 45;
            symbolpalette.PaletteItemWidth = 45;
            symbolpalette.SelectedPaletteName = "BPMN Shapes";
            symbolpalette.ShowPaletteItemText = false;            
            symbolpalette.DiagramId = "Diagram1";
            symbolpalette.Model.Palettes.Add(GenerateBasicShapes());
            symbolpalette.Model.Palettes.Add(GenerateSwimLanes());
        }
        public Palette GenerateSwimLanes()
        {
            Palette swimLanes = new Palette("Swimlane Shapes");
            swimLanes.Expanded = true;
            Lane stackCanvas1 = CreateSwimLane("stackCanvas1", "horizontal", 140, 60);
            Lane stackCanvas2 = CreateSwimLane("stackCanvas2", "vertical", 60, 140);
            swimLanes.Items.Add(stackCanvas1);
            swimLanes.Items.Add(stackCanvas2);
            GenerateSwimlanePhase(swimLanes, "verticalPhase", "vertical");
            GenerateSwimlanePhase(swimLanes, "horizontalPhase", "horizontal");
            return swimLanes;
        }
        private Lane CreateSwimLane(string name, string orientation, int width, int height)
        {
            Lane swimLane = new Lane();
            swimLane.Name = name;
            swimLane.Header.Text = "";
            //set the width for the header
            swimLane.Header.Width = 120;
            swimLane.Header.Height = 60;
            swimLane.Header.FillColor = "#C7D4DF";
            swimLane.Header.FontSize = 11;
            swimLane.Width = width;
            swimLane.Height = height;
            swimLane.Orientation = orientation;
            swimLane.FillColor = "#f5f5f5";
            swimLane.OffsetX = width / 2;
            swimLane.OffsetY = height / 2;
            return swimLane;
        }
        public void GenerateSwimlanePhase(Palette swimlaneShapes, string name, string orientation)
        {
            Phase phase = new Phase();
            phase.Name = name;
            phase.Type = "phase";
            phase.LineWidth = 1;
            phase.LineDashArray = "3,3";
            phase.LineColor = "#606060";
            phase.Orientation = orientation;
            phase.Parent = "";
            swimlaneShapes.Items.Add(phase);
        }
        public Palette GenerateBasicShapes()
        {
            Palette bpmnShapes = new Palette("BPMN Shapes");
            bpmnShapes.Expanded = true;


            BasicShape triangle = new BasicShape();
            triangle.Name = "triangle";           
            triangle.Width = 40;
            triangle.Height = 40;
            triangle.OffsetX = triangle.Width/2;
            triangle.OffsetY = triangle.Height/ 2;
            triangle.Shape = BasicShapes.Rectangle;
            CreateRectanglePorts(triangle);
            //Node triangle = CreateNodes("Triangle", "M200,10 L250,190 L160,210 Z M200,10 L250,190 L160,210 Z M120 0 L75 200 L225 200 Z", null);
            //CreateTrianglePorts(triangle);
            Node cancelboundary = CreateNodes("cancelboundary", "M30.708,48.876c-10.018,0-18.168-8.15-18.168-18.169s8.15-18.169,18.168-18.169s18.167,8.15,18.167,18.169S40.726,48.876,30.708,48.876z M30.708,13.288c-9.604,0-17.418,7.814-17.418,17.419s7.813,17.419,17.418,17.419c9.604,0,17.417-7.814,17.417-17.419S40.312,13.288,30.708,13.288zM30.709,46.878c-8.916,0-16.17-7.254-16.17-16.171s7.254-16.171,16.17-16.171s16.169,7.254,16.169,16.171S39.625,46.878,30.709,46.878z M30.709,15.286c-8.503,0-15.42,6.918-15.42,15.421s6.917,15.421,15.42,15.421c8.502,0,15.419-6.918,15.419-15.421S39.211,15.286,30.709,15.286zM30.707,61.414L0,30.707L30.707,0l30.708,30.707L30.707,61.414z M1.414,30.707L30.707,60l29.294-29.293L30.707,1.414L1.414,30.707zM23.16,41.914l-3.718-3.717l7.536-7.537L19.5,23.179l3.68-3.679l7.479,7.48l7.481-7.48l3.718,3.717l-7.48,7.481l7.48,7.479l-3.68,3.68l-7.48-7.479L23.16,41.914z M20.503,38.197l2.657,2.656l7.537-7.536l7.48,7.479l2.619-2.619l-7.48-7.479l7.48-7.481l-2.657-2.656l-7.481,7.48l-7.479-7.48l-2.619,2.618l7.479,7.481L20.503,38.197z", null);
            CreateTrianglePorts(cancelboundary);
            Node compensationboundary = CreateNodes("compensationboundary", "M30.708,12.413c-10.087,0-18.293,8.207-18.293,18.294s8.206,18.294,18.293,18.294C40.793,49.001,49,40.794,49,30.707S40.793,12.413,30.708,12.413z M30.708,48.001c-9.535,0-17.293-7.758-17.293-17.294s7.758-17.294,17.293-17.294S48,21.171,48,30.707S40.243,48.001,30.708,48.001zM30.708,14.601c-8.88,0-16.105,7.226-16.105,16.106s7.225,16.106,16.105,16.106c8.88,0,16.103-7.226,16.103-16.106S39.587,14.601,30.708,14.601z M30.708,45.813c-8.329,0-15.105-6.776-15.105-15.106s6.776-15.106,15.105-15.106c8.328,0,15.103,6.776,15.103,15.106S39.036,45.813,30.708,45.813zM30.707,0L0,30.707l30.707,30.707l30.708-30.707L30.707,0z M1.414,30.707L30.707,1.414L60,30.707L30.707,60L1.414,30.707zM29.69,24.252l-11.18,6.455l11.18,6.455v-6.007l10.404,6.007v-12.91L29.69,30.259V24.252z M39.094,25.984v9.445l-8.181-4.723L39.094,25.984z M28.69,35.43l-8.18-4.723l8.18-4.723V35.43z", null);
            CreateTrianglePorts(compensationboundary);

            Node EscalationBoundary = CreateNodes("EscalationBoundary", "M30.709,12.413c-10.088,0-18.293,8.207-18.293,18.294s8.205,18.294,18.293,18.294C40.795,49.001,49,40.794,49,30.707S40.795,12.413,30.709,12.413z M30.709,48.001c-9.535,0-17.293-7.758-17.293-17.294s7.758-17.294,17.293-17.294C40.243,13.413,48,21.171,48,30.707S40.243,48.001,30.709,48.001zM30.709,14.462c-8.957,0-16.244,7.287-16.244,16.244c0,8.958,7.287,16.245,16.244,16.245c8.956,0,16.242-7.287,16.242-16.245C46.951,21.749,39.665,14.462,30.709,14.462z M30.709,45.951c-8.406,0-15.244-6.839-15.244-15.245c0-8.405,6.838-15.244,15.244-15.244c8.404,0,15.242,6.839,15.242,15.244C45.951,39.112,39.113,45.951,30.709,45.951zM30.707,0L0,30.707l30.707,30.707l30.709-30.707L30.707,0z M1.414,30.707L30.707,1.414l29.295,29.293L30.707,60L1.414,30.707zM30.709,17.352L19.636,38.964L30.709,27.45l11.072,11.514L30.709,17.352z M22.626,34.772l8.083-15.776l8.082,15.776l-8.082-8.404L22.626,34.772z", null);
            CreateTrianglePorts(EscalationBoundary);

            Node errorEnd = CreateNodes("errorEnd", "M30.708,49.001c-10.087,0-18.293-8.207-18.293-18.294s8.206-18.294,18.293-18.294C40.794,12.413,49,20.62,49,30.707S40.794,49.001,30.708,49.001z M30.708,13.413c-9.535,0-17.293,7.758-17.293,17.294s7.758,17.294,17.293,17.294S48,40.243,48,30.707S40.243,13.413,30.708,13.413zM30.709,47.003c-8.985,0-16.295-7.311-16.295-16.296s7.31-16.296,16.295-16.296c8.984,0,16.294,7.311,16.294,16.296S39.693,47.003,30.709,47.003z M30.709,15.411c-8.434,0-15.295,6.861-15.295,15.296s6.861,15.296,15.295,15.296s15.294-6.861,15.294-15.296S39.143,15.411,30.709,15.411zM30.707,61.414L0,30.707L30.707,0l30.708,30.707L30.707,61.414z M1.414,30.707L30.707,60l29.294-29.293L30.707,1.414L1.414,30.707z", null);
            CreateTrianglePorts(errorEnd);


            Node linkcatching = CreateNodes("linkcatching", "M30.708,12.413c-10.087,0-18.293,8.207-18.293,18.294s8.206,18.294,18.293,18.294C40.794,49.001,49,40.794,49,30.707S40.794,12.413,30.708,12.413z M30.708,48.001c-9.535,0-17.293-7.758-17.293-17.294s7.758-17.294,17.293-17.294C40.242,13.413,48,21.171,48,30.707S40.242,48.001,30.708,48.001zM30.708,14.089c-9.163,0-16.618,7.455-16.618,16.618s7.455,16.618,16.618,16.618c9.162,0,16.616-7.455,16.616-16.618S39.87,14.089,30.708,14.089z M30.708,46.325c-8.612,0-15.618-7.006-15.618-15.618s7.006-15.618,15.618-15.618c8.61,0,15.616,7.006,15.616,15.618S39.318,46.325,30.708,46.325zM30.707,0L0,30.707l30.707,30.707l30.707-30.707L30.707,0z M1.414,30.707L30.707,1.414L60,30.707L30.707,60L1.414,30.707zM32.853,24.201v3.628H19.141v5.756h13.712v3.628l11.27-6.506L32.853,24.201z M20.141,32.585v-3.756h13.712v-2.896l8.27,4.773l-8.27,4.773v-2.896H20.141z", null);
            CreateTrianglePorts(linkcatching);
            //bpmnShapes.AppendChild(node2);
            bpmnShapes.AppendChild(triangle);
            bpmnShapes.AppendChild(cancelboundary);
            bpmnShapes.AppendChild(compensationboundary);
            bpmnShapes.AppendChild(EscalationBoundary);
            bpmnShapes.AppendChild(errorEnd);
            bpmnShapes.AppendChild(linkcatching);

            return bpmnShapes;
        }
        private BasicShape CreateNodes(string name, string pathData, string color)
        {
            BasicShape node = new BasicShape();
            node.Name = name;
            node.Width = 40;
            node.Height = 40;
            node.OffsetX = node.Width / 2;
            node.OffsetY = node.Height / 2;
            node.Shape = BasicShapes.Path;
            node.PathData = pathData;
            node.FillColor = color != null ? color : "white";
            node.BorderWidth = 2;
            return node;
        }
        private void CreateRectanglePorts(Node node)
        {
            node.Ports.Add(CreatePort("port7", 1, 0.5f));
            node.Ports.Add(CreatePort("port1", 0, 0.5f));
            node.Ports.Add(CreatePort("port2", 0, 0.3f));
            node.Ports.Add(CreatePort("port3", 0, 0.7f));
            node.Ports.Add(CreatePort("port4", 0.5f, 0));
            node.Ports.Add(CreatePort("port5", 0.3f, 0));
            node.Ports.Add(CreatePort("port6", 0.7f, 0));
            node.Ports.Add(CreatePort("port8", 1, 0.3f));
            node.Ports.Add(CreatePort("port9", 1, 0.7f));
            node.Ports.Add(CreatePort("port10", 0.5f, 1));
            node.Ports.Add(CreatePort("port11", 0.3f, 1));
            node.Ports.Add(CreatePort("port12", 0.7f, 1));
        }

        private void CreateTrianglePorts(Node node)
        {
            node.Ports.Add(CreatePort("port7", 1, 0.5f));
            node.Ports.Add(CreatePort("port1", 0, 0.5f));
            node.Ports.Add(CreatePort("port4", 0.5f, 0));
            node.Ports.Add(CreatePort("port10", 0.5f, 1));
        }

        
        private Port CreatePort(string name, float offsetx, float offsety)
        {
            Port port = new Port();
            port.Name = name;
            port.Offset = new DiagramPoint(offsetx, offsety);
            return port;
        }
    }
}